;Originalsource: http://www.purebasic.fr/german/viewtopic.php?p=302403#p302403
;Author: Mr.L
;Testweise erweitert: Falko
;Testweise erweitert: Dadido3
EnableExplicit

#LETTERWIDTH      = 60
#LETTERHEIGHT      = 80
#LETTERSPACING      = 5
#LETTERPOSY         = 5
#BOARDWIDTH         = 12
#BOARDHEIGHT      = 5
#BOARDMAXSPEED      = 30

Structure BoardLetter
   currentLetter.l
   targetLetter.l
   rotation.l
   speed.l
EndStructure


Structure Letter
   upperImage.i
   lowerImage.i
EndStructure

Global NrLetters
Global Dim LetterNr(255)
Global Dim Letter.Letter(255)
Global Dim Board.BoardLetter(#BOARDWIDTH, #BOARDHEIGHT)

LoadFont(0,"Helvetiva", #LETTERHEIGHT / 1.8, #PB_Font_HighQuality | #PB_Font_Bold)

InitSound()
UseOGGSoundDecoder()
#Sounds = 9
Define i
For i = 0 To #Sounds-1
  LoadSound(i, "Click_"+Str(i)+".ogg")
Next
;CatchSound(0,?Klappern_einzel)

Procedure DrawLetter(letterNr, angle, x, y)
   Protected h2, nextLetter, sizeY
   
   h2         = #LETTERHEIGHT / 2
   sizeY      = Cos(Radian(angle)) * #LETTERHEIGHT * 0.5
   nextLetter   = (letterNr + 1)
   If nextLetter >= NrLetters
      nextLetter = 0
   EndIf
   
   DrawImage( ImageID(Letter(nextLetter)\upperImage), x, y - 1)
   DrawImage( ImageID(Letter(letterNr)\lowerImage), x, y + h2 + 1)
   If angle < 90
     DrawImage(ImageID(Letter(letterNr)\upperImage), x, y + h2 - sizeY - 1, #LETTERWIDTH, sizeY)
   Else
     DrawImage( ImageID(Letter(nextLetter)\lowerImage), x, y + h2 + 1, #LETTERWIDTH, -sizeY)
   EndIf
   Box(x, y - 1, #LETTERWIDTH, h2, RGB(50, 50, 50))
   Box(x, y + h2 + 1, #LETTERWIDTH, h2 - 1, RGB(50, 50, 50))
   Box(x + 1, y + h2 - 4, 2, 8, 0)
   Box(x + #LETTERWIDTH - 3, y + h2 - 4, 2, 8, 0)
   Line(x, y, #LETTERWIDTH, 1, RGB(100,100,100))
   Line(x + 3, y + h2 + 1, #LETTERWIDTH - 6, 1, RGB(100,100,100))
   If Angle = 0
    PlaySound(Random(#Sounds-1),#PB_Sound_MultiChannel)
   EndIf
EndProcedure

Procedure UpdateBoard()
   Protected x, y
   StartDrawing(CanvasOutput(0))
   DrawingMode(#PB_2DDrawing_Outlined)   
   For y = 0 To #BOARDHEIGHT - 1
     For x = 0 To #BOARDWIDTH - 1
       With Board(x,y)
            If \currentLetter <> \targetLetter
               \speed = Abs(\currentLetter - \targetLetter) * 4
               If \speed > #BOARDMAXSPEED
                  \speed = #BOARDMAXSPEED
               EndIf
               \rotation + \speed
               If \rotation > 180
                  \rotation = 0
                  \currentLetter + 1
                  If \currentLetter >= NrLetters
                     \currentLetter = 0
                  EndIf
               EndIf
               DrawLetter(\currentLetter, \rotation, x * (#LETTERWIDTH + #LETTERSPACING) + 3, y * (#LETTERHEIGHT + #LETTERSPACING) + 3)
            EndIf            
         EndWith
      Next
   Next
   StopDrawing()
   
EndProcedure

Procedure SetBoardText(RowNr, Text$)
   Protected l
   
   Text$ = LSet(Text$, #BOARDWIDTH, " ")
   For l = 1 To Len(Text$)
     If l <= #BOARDWIDTH
       Board(l - 1, RowNr)\targetLetter = LetterNr(Asc(Mid(Text$, l, 1)))
      EndIf
   Next
EndProcedure

Procedure InitBoard(canvasID, letterList$, letterNr)
   Protected l, a, x, y
   
   NrLetters = Len(letterList$)
   
   For l = 0 To NrLetters - 1
      a = Asc(Mid(letterList$, l + 1, 1))
      LetterNr(a)            = l
      Letter(l)\upperImage   = CreateImage(#PB_Any, #LETTERWIDTH, #LETTERHEIGHT / 2)
      Letter(l)\lowerImage   = CreateImage(#PB_Any, #LETTERWIDTH, #LETTERHEIGHT / 2)
      StartDrawing(ImageOutput(Letter(l)\upperImage))
      DrawingFont(FontID(0))
      DrawingMode(#PB_2DDrawing_Gradient)
      LinearGradient(0,0,0,OutputHeight())
      GradientColor(0, RGB(15,15,15))
      GradientColor(1, RGB(50,50,50))
      Box(0, 0, OutputWidth(), OutputHeight())
      DrawingMode(#PB_2DDrawing_Transparent)      
      DrawText((#LETTERWIDTH - TextWidth(Chr(a))) / 2, #LETTERPOSY, Chr(a), RGB(255,250, 150))
      Line(0, 0, #LETTERWIDTH, 1, RGB(80,80,80))
      StopDrawing()
      StartDrawing(ImageOutput(Letter(l)\lowerImage))
      DrawingMode(#PB_2DDrawing_Gradient)
      LinearGradient(0,0,0,OutputHeight())
      GradientColor(1, RGB(15,15,15))
      GradientColor(0, RGB(50,50,50))
      Box(0, 0, OutputWidth(), OutputHeight())
      DrawingMode(#PB_2DDrawing_Transparent)
      DrawingFont(FontID(0))
      DrawText((#LETTERWIDTH - TextWidth(Chr(a))) / 2, -#LETTERHEIGHT / 2 + #LETTERPOSY, Chr(a), RGB(255,250, 150))
      Line(0, #LETTERHEIGHT / 2 - 2, #LETTERWIDTH, 1, RGB(80,80,80))
      StopDrawing()
     
   Next
   
   StartDrawing(CanvasOutput(canvasID))
   Box(0, 0, OutputWidth(), OutputHeight(), RGB(30, 30, 30))
   DrawingMode(#PB_2DDrawing_Outlined)   
   For y = 0 To #BOARDHEIGHT - 1
      For x = 0 To #BOARDWIDTH - 1
         With Board(x,y)
            \currentLetter   = letterNr
            \targetLetter   = letterNr
            \speed         = 0
            \rotation      = 0
            DrawLetter(\currentLetter, \rotation, x * (#LETTERWIDTH + #LETTERSPACING) + 3, y * (#LETTERHEIGHT + #LETTERSPACING) + 3)
         EndWith
      Next      
   Next   
   StopDrawing()
EndProcedure

DisableExplicit

OpenWindow(0, 0, 0, #BOARDWIDTH * (#LETTERWIDTH + #LETTERSPACING), #BOARDHEIGHT * (#LETTERHEIGHT + #LETTERSPACING), "PB Timetable", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
CanvasGadget(0, 0, 0, WindowWidth(0), WindowHeight(0))

InitBoard(0, " !.0123456789:ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz", 0)

Repeat
   time   = ElapsedMilliseconds()
   elapsed   = time - displayUpdateTime
   
   If elapsed < 10000
      SetBoardText(0, "HELLO WORLD!")
      SetBoardText(1, "")
      SetBoardText(2, "PureBasic is")
      SetBoardText(3, "really cool!")
      SetBoardText(4, "")
   ElseIf elapsed < 30000
      SetBoardText(0, "")
      SetBoardText(1, "CURRENT TIME:")
      SetBoardText(2, "")
      SetBoardText(3, "  " + FormatDate("%hh:%ii:%ss", Date()))
      SetBoardText(4, "")
   ElseIf elapsed < 40000
      SetBoardText(0, "    made")
      SetBoardText(1, "     by")
      SetBoardText(2, "    Mr.L")
      SetBoardText(3, "")
      SetBoardText(4, "...have fun!")
   Else
      displayUpdateTime = time
   EndIf
   
   UpdateBoard()

   While ElapsedMilliseconds() < waitTime
   Wend
   waitTime = time + 10
   
 Until WindowEvent() = #PB_Event_CloseWindow
 
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 32
; Folding = -
; EnableXP
; IDE Options = PureBasic 4.60 Beta 4 (Windows - x64)
; CursorPosition = 193
; Folding = -
; EnableXP
; DisableDebugger